#ifndef BIBLIO_H_INCLUDED
#define BIBLIO_H_INCLUDED

//  biblio.h: bibliogafa
//  Fecha: 13/10/2020; 8:35 am
//  S. Galliano.

#include <string>
#include <utility>
typedef std::string Str;
typedef std::pair<Str, Str> Data;

class Obra {
public:
    Obra() {}
    void setDT( Data & valor ) { dato = valor; }
    Data getDT() const { return dato; }
    void entrarObra( Str nombre, Str titulo );
    void mostrarObra()           const;
    bool obraEsta( Str titulo )  const;
    bool autorEsta( Str nombre ) const;
private:
    Data dato;
};

#endif // BIBLIO_H_INCLUDED
