#ifndef NOMINA_H_INCLUDED
#define NOMINA_H_INCLUDED

// nomina.h: ejercicio 6
// Fecha: 24/10/2020; 7:40 am

#include <string>
typedef std::string Str;

//  tipificacin de mensajes
const Str HECHO( "\255Hecho!\n\n" );
const Str MSG_N( "No est\240.\n\n" );
const Str MSG_Y( "Ya est\240.\n\n" );
const Str MSG_V( "N\242mina vac\241a.\n\n" );
const Str ERR_A( "No puedo abir el archivo.\n\n" );

#include "obrero.h"
#include <vector>
typedef std::vector<Obrero> Vct;

class Nomina {
public:
    bool estaVacia() const;
    bool yaEsta( Obrero &nodo ) const;
    void borrar( Obrero &nodo );
    void entrar( Obrero &nodo );
    void editar( Obrero &nodo );
    void escribir( std::ostream & Escribiendo );
    void subir();
    void vaciar();
    int contar() const;
private:
    Vct vct;
};


#endif // NOMINA_H_INCLUDED
