// Programa de prueba
// Fecha: 4/10/2020; 9 am
#include "base.h"
#include <algorithm>

// funcin de ordenamiento
bool menor( const Piezas * n1, const Piezas * n2 ) {
    if ( n1->getPieza() < n2->getPieza() )
        return true;
    else
        return false;
}

int Base::getVctSize() const { return vct.size(); }
void Base::ordenar() { sort( vct.begin(), vct.end(), menor ); }
void Base::insertar( Piezas *pParte ) { vct.push_back( pParte ); }

bool Base::buscar( Piezas *pParte ) {
    bool resp( false );

    for ( auto x: vct ) {
        if ( x->getPieza() == pParte->getPieza() ) {
            resp = true;
            break;
        }
    }

    return resp;
}

#include<iostream>
void Base::borrar( Piezas *pParte ) {
    if ( buscar( pParte) ) {
        Vct::iterator i = vct.begin();

        for ( auto x : vct ) {
            if ( x->getPieza() == pParte->getPieza() ) {
                vct.erase( i );
                std::cout << "Nodo borrado\n\n";
                return;
            }

            ++i;
        }
    } else
        std::cerr << ERR_N;
}

void Base::mostrar() {
    ordenar();

    for ( auto x: vct )
        x->muestra();
}
