#ifndef BASE_H_INCLUDED
#define BASE_H_INCLUDED

// Programa 13
// Fecha: 4/10/2020; 9 am
#include "piezas.h"
#include <string>
typedef std::string Str;
const Str ERR_V( "Base vac\241a.\n\n" );
const Str ERR_Y( "Ya est\240.\n\n" );
const Str ERR_N( "No est\240.\n\n" );

#include <vector>
typedef std::vector<Piezas *> Vct;

// funcin de ordenamiento
bool menor( const Piezas * n1, const Piezas * n2 );

class Base {
public:
    Base() { vct.clear(); }
    int getVctSize() const;
    void mostrar();
    void ordenar();
    void insertar( Piezas *pParte );
    bool buscar( Piezas *pParte );
    void borrar( Piezas *pParte );
private:
    Vct vct;
};

#endif // BASE_H_INCLUDED
