// Programa 13
// Fecha: 4/10/2020; 9 am
#include "piezas.h"
#include <iostream>

// inplementacin de una funcin virtual-pura para
// que pueda encadenarse en las clases-hijas
void Piezas::muestra() const { std::cout << "Pieza No.: " << pieza; }

// Piezas de auto
Auto::Auto( uLong laPieza, uShort elModelo ) :
    Piezas( laPieza ),
    modelo( elModelo ) {}

void Auto::muestra() const {
    Piezas::muestra();
    std::cout << "\tModelo del a\244o " << modelo << '\n';
}

// piezas de avin
Avion::Avion( uLong laPieza, uShort losMotores ):
    Piezas( laPieza ),
    motores( losMotores ) {}

void Avion::muestra() const {
    Piezas::muestra();
    std::cout << "\tN\243m. motores = " << motores << '\n';
}
