// Programa 19: benchmark
// Fecha: 16:26 viernes, 12 de abril de 2019
// Revisin: 4/9/2020; 7:15 am
// S. Galliano.

#include "../../Programas/deposito/crono.h"
#include "benchmk.h"
#include <iostream>
#include <cstdlib>
#include <ctime>

//  tiempos de 1984
const int AT    = 3*60; // 3 min
const int PC    = 8*60; // 8 min
const int NUMS  = 10000;
const int VECES = 1000;

int main() {
    //  info
    std::cout <<
    "Ejercicio 10: prueba la eficiencia de este sistema, aplicando\n"
    "la criba de Erat\242stenes a " << NUMS << " n\243meros, " <<
    VECES << " veces.\n\nTiempos de 1984 para una AT = " << AT/60 <<
    " min; PC = " << PC/60 << " min.\n\nTenga paciencia, estoy trabajando. . .";

    Crono tiempo;
    tiempo.start();
    double t = 0;

    for ( int i = 0; i < VECES; ++i ) {
        for ( int j = 2; j < NUMS; ++j ) {
            esPrimo( j );
        } // for j
    } // for i

    //time_t fin = clock();
    tiempo.stop();
    t = tiempo.reportar();

    //  respuesta en minutos
    std::cout <<
    "tard\202 " << t/60 << " min.\n\n"
    "Este sistema es:\n" <<
    ( 1 - t / AT ) * 100 << "% mejor que la AT.\n" <<
    ( 1 - t / PC ) * 100 << "% mejor que la PC.\n\n";

    //  fin
    system( "pause" );
    return EXIT_SUCCESS;
}
