// calc.h: ejercicio 14, una calculadora RPN
// Fecha: 10/110/2020; 4:50 pm
#include "calc.h"

int MotorCalc::MemActual() { return dato.top(); }

void MotorCalc::pushOp( int valor ) { dato.push( valor ); }

void MotorCalc::ejecuta( opBinaria laOp ) {
    int lhs = dato.top();
    dato.pop();
    int rhs = dato.top();
    dato.pop();

    switch ( laOp ) {
    case Suma:
        dato.push( lhs + rhs );
        break;
    case Resta:
        dato.push( lhs - rhs );
        break;
    case Producto:
        dato.push( lhs * rhs );
        break;
    case Division:
        dato.push( rhs / lhs );
        break;
    }
}
