#ifndef ANIMAL_H
#define ANIMAL_H

//  Programa auxiliar 2: mtodos estticos (2)
//  Fecha: 7/10/2020; 6:10 pm
//  S. Galliano

#include <iostream>

class Animal {
public:
    Animal() {
        edad = 0;
        ++cuantosSon;
    }
    virtual ~Animal() { --cuantosSon; }
    virtual short getEdad() const { return edad; }
    virtual void  setEdad( short valor ) { edad = valor; }
    virtual void Habla() const {}
    static int getAnimal() { return cuantosSon; }
private:
    short edad;
    static int cuantosSon;
};

int Animal::cuantosSon = 0;

class Perro : public Animal {
public:
    Perro() {}
    virtual ~Perro() {}
    virtual void Habla() const { std::cout << "\255Guau, Guau!\n"; }
};

class Gato : public Animal {
public:
    Gato() {}
    virtual ~Gato() {}
    virtual void Habla() const { std::cout << "Miau...\n"; }
};

#endif // ANIMAL_H

