#ifndef ERROR_H_INCLUDED
#define ERROR_H_INCLUDED

// error.h: programa auxiliar 3, divisin por cero
// Fecha: 18/11/2020; 2 pm

#include <stdexcept>      // contiene la clase
using std::runtime_error; // clase runtime_error

// el objeto DivisionPorCero hereda pblicamente de la clase
// runtime_error y ser lanzado cuando se detecte este error
struct DivisionPorCero : public runtime_error {
    // el constructor especifica el mensaje de error
    DivisionPorCero() : runtime_error( "  No puedo dividir por cero." ) {}
};

// entrada: dos nmeros reales
// salida: la divisin
double entre( double x, double y );

#endif // ERROR_H_INCLUDED
