//  frutas.cpp: definiciones para el programa 5
//  Fecha: 16/7/2020; 4:30 pm
//  Revisin: 3/10/2020; 5:24 pm
//  Por: S. Galliano.
#include "frutas.h"
#include <iostream>
using std::cout;

// clase base Fruta
Fruta::Fruta( Str nb, Str cl ) : nombre( nb ), color( cl ) {}
//  getters
Str Fruta::getNombre() const { return nombre; }
Str Fruta::getColor()  const { return color;  }
//  mtodo que muestra las partes comunes
void Fruta::muestra() { cout << getNombre() << " es de color " << getColor() << '\n'; }

// Clase especfica Naranja
Naranja::Naranja( Str nb, Str cl, bool co, bool ju )
    : Fruta( nb, cl),                   // primero va la madre
      comestible( co ), jugosa( ju ) {} // luego, la hija
// vista
void Naranja::muestra() {
    Fruta::muestra(); // muestra la parte comn
    // y ahora las partes especficas
    jugosa ? cout << "Es " : cout << "No es ";
    cout << "buena para zumo.\n";
    comestible ? cout << "Es " : cout << "No es ";
    cout << "buena para comer.\n\n";
}

// Clase especfica Platano
Platano::Platano( Str nb, Str cl, bool co )
    : Fruta( nb, cl ),     // primero va la madre
      comestible( co ) {}  // luego, la hija
// vista
void Platano::muestra() {
    Fruta::muestra(); // muestra la parte comn
    // y ahora la parte especfica
    comestible ? cout << "Es " : cout << "No es ";
    cout << "muy bueno para comer.\n\n";
}
