#ifndef MAMIFERO_H_INCLUDED
#define MAMIFERO_H_INCLUDED

//  mamifero.h: declaraciones para el programa 06
//  Fecha: 29/9/2020; 10:35 am
//  Revisin: 3/10/2020 7:20 pm
//  S. Galliano
#include <iostream>

class Mamifero {
public:
    Mamifero() : raza( "" ) {}
    Mamifero( std::string rz );
    virtual ~Mamifero() {}
    // acesores
    void setRaza( std::string valor ) { raza = valor; }
    std::string getRaza() const { return raza; };
    // mtodos
    virtual void Hablar() const = 0;// <-- clase virtual pura
    virtual void Moverse( int n ) const {};
    virtual void Mostrarse() const {};
private:
    std::string raza;
};

class Perro : public Mamifero {
public:
    Perro() : nombre( "" ) {}
    Perro( std::string rz, std::string nb );
    virtual ~Perro () {}
    void setNombre( std::string valor ) { nombre = valor; }
    std::string getNombre() const { return nombre; }
    virtual void Hablar() const;
    virtual void Moverse( int n ) const;
    virtual void Mostrarse() const;
private:
    std::string nombre;
};

class Gato : public Mamifero {
public:
    Gato() : color( "" ) {}
    Gato( std::string rz, std::string cl );
    virtual ~Gato () {}
    void setColor( std::string valor ) { color = valor; }
    std::string getColor() const { return color; }
    virtual void Hablar() const;
    virtual void Moverse( int n ) const;
    virtual void Mostrarse() const;
private:
    std::string color;
};

#endif // MAMIFERO_H_INCLUDED
