#ifndef ANIMAL_H
#define ANIMAL_H

//  Programa 09: herencia (3)
//  Fecha 29/9/2020; 7:22 pm
//  Revisin: 6/10/2020; 5:34 pm
//  S. Galliano

#include <iostream>
typedef int MANOS;
enum COLOR { Rojo, Verde, Azul, Amarillo, Blanco, Negro, Bayo, Pinto };

class Animal { // base comn, es virtual pura y va primero
public:
    Animal( COLOR elColor, short laEdad );
    virtual ~Animal() {  std::cout << "Destructor de un Animal...\n"; }
    virtual int getColor()  const { return color; }
    virtual short getEdad() const { return edad; }
    // todos los comportamientos de las hijas deben ser declarados aqu
    virtual void Relincha() const = 0;
    virtual MANOS getAlto() const { return 1;}
    virtual void Vuela() const {}
    virtual bool getMigracion()  const { return false; }
    virtual short getCreyentes() const { return 1; }
private:
    COLOR color;
    short edad;
};

class Pajaro : virtual public Animal {
public:
    Pajaro( COLOR elColor, short laEdad, bool migra );
    virtual ~Pajaro() { std::cout << "Destructor de un P\240jaro...\n"; }
    virtual void Vuela() const { std::cout << "\255Puedo volar!\n"; }
    virtual bool getMigracion() const { return migracion; }
private:
    bool migracion;
};

class Caballo : virtual public Animal {
public:
    Caballo( COLOR elColor, short laEdad, MANOS elAlto );
    virtual ~Caballo() { std::cout << "Destructor de un Caballo...\n"; }
    virtual void Relincha() const { std::cout << "\255Whijiji!\n"; }
    virtual MANOS getAlto() const { return altura; }
private:
    MANOS altura;
};

class Pegaso : public Caballo, public Pajaro {
public:
    Pegaso( COLOR elColor, short laEdad, MANOS elAlto, bool migra, short creen );
    virtual ~Pegaso() { std::cout << "Destructor de un Pegaso...\n"; }
    void setEdad( int laEdad ) {}
    void Vuela()    const { Pajaro::Vuela(); }
    void Relincha() const { Caballo::Relincha(); };
    int getColor()  const { return Animal::getColor(); }
    short getCreyentes() const { return creyentes; }
private:
    short creyentes;
};

#endif // ANIMAL_H
