//  Programa 11: una clase minimax
//  Fecha: 3/10/2020; 9 am
//  S. Galliano

//  Programa 11: una clase minmax
#include "../deposito/rnd.h"
#include <iostream>
#include <cstdlib>
#include <vector>
#include <iterator>
#include <algorithm>
#include <ctime>

class MiniMax {
public:
    MiniMax( std::vector<int> vct ) : v(vct), minInt(0), maxInt(0) {}
    std::pair<int, int> buscar();
private:
    std::vector<int> v;
    int minInt;
    int maxInt;
};

std::pair<int, int> MiniMax::buscar() {
    minInt = *min_element( v.begin(), v.end() );
    maxInt = *max_element( v.begin(), v.end() );
    return std::make_pair( minInt, maxInt );
}

const int N = 10, P = 20, Q =80;

int main() {
    std::cout << "Problema 11: una clase MiniMax.\n\n";
    std::vector<int> vct( N );
    srand( time( nullptr ) );
    RELLENA_I( vct, P, Q );
    MiniMax mm( vct );
    std::pair<int, int> par = mm.buscar();
    std::copy( vct.begin(), vct.end(), std::ostream_iterator<int>( std::cout, ", " ) );
    std::cout << "\b\b \n";
    std::cout << "M\241n = " << par.first  << '\n'
              << "M\240x = " << par.second << "\n\n";
    system( "pause" );
    return EXIT_SUCCESS;
}
