//  Problema 4: una BD
//  Fecha: 11/10/2020; 8:13 am
//  S. Galliano

#include "menu.h"
#include "almacen.h"
#include <iostream>
#include <cstdlib>

const Str info( "Ejercicio 4: una base de datos.\n\n" );

int main() {

    Almacen * pInv = new Almacen; // el inventario
    unsigned opcion;              // la opcin del men
    Str mk;                       // una marca
    using std::cout;
    using std::cin;
    using std::cerr;

    while ( true ) {
        opcion = menu( info );

        if ( Terminar == opcion ) {
            delete pInv;
            return EXIT_SUCCESS;
        }

        switch ( opcion ) {
        case Ayudar:
            ayuda( info );
            break;
        case Mostrar:
            pInv->mostrar();
            break;
        case Adicionar:
            std::cout << "Nueva marca: ";
            std::getline( std::cin, mk );
            pInv->adicionar( mk );
            break;
        case Borrar:
            std::cout << "Marca a borrar: ";
            std::getline( std::cin, mk );
            pInv->borrar( mk );
            break;
        case Editar:
            std::cout << "Para cambiar el precio.\nMarca: ";
            std::getline( std::cin, mk );
            pInv->editar( mk );
            break;
        case Vaciar:
            char sn;
            std::cout << "\250Vaciar el inventario? (s/n): ";
            std::cin >> sn;

            if ( 'S' == toupper( sn ) )
                pInv->vaciar();
            break;
        } // switch

        system( "pause" );
    }
}
