// Problema 7: una clase functor
// Fecha: 14/10/2020; 9:35 pm
// S. Galliano.

#include "estads.h"
#include <iostream>
#include <cstdlib>
#include <fstream>
#include <algorithm>
#include <iomanip>

int main() {
    using namespace std;
    cout << "Ejercicio 7: una clase functor.\n\n";
    std::ifstream leer( "C://temp//datos.txt" );

    if ( leer.fail() ) {
        std::cerr << "Fall\242 la lectura. Abortando.\n";
        return EXIT_FAILURE;
    }

    int valor;
    vInt vint;

    while ( leer >> valor )
        vint.push_back(valor);

    Estads stI = for_each( vint.begin(), vint.end(), Estads(vint) );
    cout << std::setprecision( 4 ) << std::fixed;
    cout << "Media   = " << std::setw( 9 ) << stI.media()   << '\n';
    cout << "Mediana = " << std::setw( 9 ) << stI.mediana() << '\n';
    cout << "Moda    = " << std::setw( 4 ) << stI.moda()    << '\n';
    cout << "Varz.   = " << std::setw( 9 ) << stI.varza()   << '\n';
    cout << "Desviac.= " << std::setw( 9 ) << sqrt( stI.varza() ) << '\n';
    cout << "M\240ximo  = " << std::setw( 4 ) << stI.Max()  << '\n';
    cout << "M\241nimo  = " << std::setw( 4 ) << stI.Min()  << '\n';
    cout << "Rango   = " << std::setw( 4 ) << stI.Max() - stI.Min() << '\n';
    cout << "Suma    = " << std::setw( 4 ) << stI.suma()    << '\n';
    cout << "Cuenta  = " << std::setw( 4 ) << stI.cuenta()  << "\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
