#ifndef NOTAS_H_INCLUDED
#define NOTAS_H_INCLUDED

// notas.h: declaraciones para el ejercicio 10
// Fecha: 27/10/2020; 10:33 am

#include <string>
#include <vector>
#include <valarray>
typedef std::string Str;
typedef std::vector<Str> Vct;
typedef std::valarray<double> Vad;

const Str ERR( "El fichero no abri\242. Abortando.\n" );
const Str PRE( "E:/Texto/Tomo 3/Ejercicios/datos/" ); // prefacio a los ficheros
const Str POS( ".txt" );                              // adenda a los ficheros

class Notas {
public:
    // accesores
    void setF( int valor ) { fil = valor; }
    void setC( int valor ) { col = valor; }
    int  getF() const { return fil; }
    int  getC() const { return col; }
    // métodos
    void cargarMats( Str archy );
    void cargarNots( Str archy );
    void ponerLinea( char ch );
    void calcular();
    void tabular();
private:
    Vct vMats;
    Vad vNots;
    int fil, col;
};

#endif // NOTAS_H_INCLUDED
