#ifndef CRONO_H_INCLUDED
#define CRONO_H_INCLUDED

//  crono.cpp: definiciones para el problema 3
//  Fecha: 13/10/2019; 8:07 am
//  Revisin: 15/9/2020; 8:26 am
//  versin sobre Halterman, 16.2-STOPWATCH, pg. 477

#include <ctime>

/**
    @brief Crono: un crongrafo. Galliano, 2020.
*/
class Crono {
public:
    Crono();
    void start();
    void stop();
    void reset();
    bool estaContando() const;
    double reportar();
private:
    time_t comienzo;
    bool contando;
    double transcurrido;
};

#endif // CRONO_H_INCLUDED
