//  Programa 08: herencia (3)
//  Fecha 29/9/2020; 7:22 pm
//  Revisin: 8:30 pm
//  S. Galliano
#include "animal.h"
using std::cout;

Animal::Animal( COLOR elColor, short laEdad ):
    color( elColor ), edad( laEdad ) { cout << "Constructor de un Animal...\n"; }

int Animal::getColor() const { return color; } ;

Caballo::Caballo( COLOR elColor, short laEdad, MANOS elAlto ):
    Animal( elColor, laEdad ), altura( elAlto ) { cout << "Constructor de un Caballo...\n"; }

Pajaro::Pajaro( COLOR elColor, short laEdad, bool migra ):
    Animal( elColor, laEdad ), migracion( migra ) { cout << "Constructor de un P\240jaro...\n"; }

Pegaso::Pegaso (
    COLOR elColor,
    short laEdad,
    MANOS elAlto,
    bool migra,
    short creen ):
        Animal( elColor, laEdad ),
        Caballo( elColor, laEdad, elAlto ),
        Pajaro( elColor, laEdad, migra ),
        creyentes( creen )
    { cout << "Constructor de un Pegaso...\n"; }
