// Programa 12: plantilla
// Fecha: 29/9/2020; 8:23 pm
// S. Galliano Nota eta = 40%

#include "../deposito/rnd.h"
#include "../deposito/print.h"
#include "plantilla.h"
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <iomanip>
#include <iterator>

const int N = 10, P = 1, Q = 50;

int main() {
    using std::cout;
    cout << "Problema 12: una plantilla de clases.";
    srand( time( nullptr) );
    cout << "\n\nCon una lista de 15 enteros:\n";
    std::list<int> lst( 1.5 * N );
    RELLENA_I( lst, P, Q );
    LISTA( lst );
    MiniMax<int> mi( lst );
    std::pair<int, int> pi = mi.buscar();
    cout << "\nM\241n = " << pi.first  << '\n'
         << "M\240x = "   << pi.second;

    cout << "\n\nCon una doble cola de 12 cortos:\n";
    std::deque<short> dek( 1.2 * N );
    RELLENA_I( dek, P, Q );
    LISTA( dek );
    MiniMax<short> ms( dek );
    std::pair<short, short> ps = ms.buscar();
    cout << "\nM\241n = " << ps.first  << '\n'
         << "M\240x = "   << ps.second;

    cout << "\n\nCon un vector de 6 reales:\n";
    std::vector<double> vct( 0.6 * N );
    RELLENA_R( vct, P, Q );
    LISTA( vct, "", 2 );
    MiniMax<double> md( vct );
    std::pair<double, double> pd = md.buscar();
    cout << std::fixed << std::setprecision( 2 )
         << "\nM\241n = " << pd.first  << '\n'
         << "M\240x = "   << pd.second << "\n\n";

    system( "pause" );
    return EXIT_SUCCESS;
}
