// estads.cpp: definiciones de una clase functor
// Fecha: 1/10/2020; 1:12 pm
// Revisin: 16/10/2020: 2:25 pm
#include "estads.h"
Estads::Estads() : n( 0 ) { v.clear(); }
Estads::Estads( std::vector<int> & vct ) : v( vct ) {
    sort( v.begin(), v.end() );
    n = v.size(); }

int Estads::cuent() const { return n; }
int Estads::suma() const { return accumulate( v.begin(), v.end(), 0.0 ); }
double Estads::media() const { return static_cast<double>( suma() ) / n; }

double Estads::varza() const {
    return static_cast<double>( SDC() - suma() * suma() / n ) / ( n - 1 );
}

int Estads::SDC() const {
    std::vector<int>aux( v );
    transform( aux.begin(), aux.end(), aux.begin(), aux.begin(), std::multiplies<int>() );
    return accumulate( aux.begin(), aux.end(), 0 );
}

double Estads::medin() const {
    double md;
    int idx = 0.5 * n;
    n % 2 ? md = v[idx] : md = 0.5 * ( v[idx - 1] + v[idx] );
    return md;
}
